# 5.3.1
Released on 2024-07-26

- Bug fixes
  - E-mail notifications
    - Attachments selection via Reference returns files from first referenced object only (#1476)
    - Ignore (deleted) objects in referenced property when Attachments selection set to Reference (#1478)

# 5.3.0
Released on 2024-07-18

- Features
  - Extended permissions
    - Fix configuration descriptions (#1470)
	
  - SQL integration module
    - Add option Value from to dynamic queries and parameters in sql settings (#1445)
	  - Sql server - extract connection string parameters as separate configuration options (#1463)
	
  - Http integration
	  - Save files - Add option to update first file when filename is empty and update file content set to true (#1471)
	  - Show option to convert object to SFD when save files configuration is not empty (#1486)
	  - Set properties - Add option to set static properties based on a response (#1487)

  - Reporting
    - Add new setting to excel settings - ConvertNumericData (#1475)
  
  - Word writer
    - Insert tables to word (#1466)
	
  - Document processing
	 - New action - Add blank page (#1498)
	
- Bug fixes
  - Other
	 - Passwords are not hidden in collection items (#1331)

# 5.2.0
Released on 2024-06-26

- New modules
  - Extended permissions (#1244)
  - Word writer (#1165)
  
- Features
  - SQL integration module
    - Add option to set static properties (#1427)
	  - Add option to set properties on - Targets (#1345)

  - Reporting
    - Enable selecting background execution mode (#1404)
	  - Objects to export - Add option to search targets by reference (#1325)
	  - Advanced word report with paragraphs, tables and text (#1217)
  
  - Document processing
	  - On replace file action keep original file name (#1415)
	  - Add option for dynamic values when setting Merged file name (#1315)
	  - Add option to delete (remove) file from object (#1364)
	  - Add option to add or replace file (#1296)
	  - Add option to add barcode/qr code (#190)
	  - Add option to read barcode (#1284)

  - Excel reader
    - Add option to Skip existing rows or columns (#1382)
    - Map by options for lookup properties in row or column mappings (#1314)
    - Add support to extract multiple objects from horizontal range table (#1214)
	
  - Word reader
	  - Map by options for lookup properties in word mappings (#1361)
	
  - Orchestrator
	  - Support for FileBased modules (Excel writer and Word writer) (#1287)
	
  - Vault to vault
    - Add new action Read. And option to save created object ID on source in Create action (#1247)
  
  - Other
    - Add support for OAuth (O365) in E-mail notifications and Reporting module (#709)
	
- Bug fixes
  - Data transfer
	  - Add export folder path type to get static or dynamic folder path (#1207)

  - Excel reader
	  - Handle duplicated rows or columns in excel table data (#1399)	
	
  - Document processing
	  - AddOrReplaceFile action - ReplaceOnCustomObject - keep single file or multi-file behavior (#1316)	
	
  - Http integration
	  - Parsing XML with multiple root element (#1248)
	  - Filename expression field missing when Filename expression type is Dynamic, Static or XPath (#1192)
	
  - Excel writer
	  - Content below the range is overwritten in copy range action (#1233)
  
# 5.0.0
Released on 2024-02-27

- Features
  - Http integration
    - Add PATCH method to HTTP module (#1178)
  
  - Other
    - Merge EK and EK cloud repositories (#1097)
    - Upgrade VAF and change logging (#1149)

# 4.8.4
Released on 2024-01-31

- Bug fixes
  - Document processing
    - Get file from Reference or Custom object returns only the first object in MergeDocuments file action (#1180)

# 4.8.2
Released on 2024-01-23

- Bug fixes
  - Orchestrator
    - Missing rule picker for Word reader module (#1138)

# 4.8.0
Released on 2024-01-19

- New modules
  - Excel writer (#824)
  - Word reader (#646)
  
- Features
  - Reporting
    - Enable SFD - MFD conversion for AddAsAdditionalFile type of export  (#112)
    - Setting datatype to multi line text, when using text and multi lookup properties in dynamic condition to avoid trimming long text (#821)
    - Add dynamic expression in properties to export (#853)
    - Option to set properties on source object (#546)
    - Object changed loop - Add validation to configuration and prevent rule execution in such cases (#832)
	
  - Word reader
    - Wildcard support for multiple table load (#756)
	
  - Property operations
    - Option to choose delimiter for multi select properties (#774)
    - Property setter - standardize dynamic search conditions in specify search with vault search (#1024)
	
  - Extended auto properties
    - Option to choose delimiter for multi select properties (#774)
	  - New optional parameter Transliterate in ToLower and ToUpper text expressions, and new text expression Replace (#773)
	  - Max & Min date auto property functions (#714)
	  - User Expressions - enable taking login account information (#918)
	
  - Excel reader
    - Custom lookup values delimiter in row or column mapping (#819)
    - Set properties from source object (#824)
	
  - Excel writer
    - Add option to populate sheet cell (#864)
	
  - Object creation
    - Add duplicate detection (#889)
    - Enable option to choose between single and multi file document (#935)
	
  - Property builder
    - Rollback query removed from configuration in property builder module (#787)
	
  - Http integration
    - Add support to set object multilookup property from response with result cardinality set to Array (#1011)
    - Add object creation from Http response (#1051)
    - Save file from XML Http response (#1085)
	
  - Orchestrator
    - Validation rule exception with custom message not thrown (#1019)
	
  - Other
    - Property Builder TAF tests (#65)
    - New operators Is contained in, Is not contained in (#776)
    - New trigger - ObjMetadataChanged (#824)

- Bug fixes

  - Document processing
    - Text overlay when adding signatures in location (#972)
	
  - Word reader
    - Lookup property delimiter missing in Table mappings (#782)
    - Multiple objects failing to create with FromHeader option (#988)
    - Empty rows are not skipped in vertical tables (#1076)
	
  - Excel reader
    - Horizontal range M-Files action - bug in reading columns from table (#842)
    - Bug in reading mixed value types in column from range object (#1015)
    - Properties from source object are creating duplicated objects from horizontal range (#1020)
	
  - Excel writer
    - Bug in populating multiple file actions in one rule (#879)
    - CopyContent action problem with merged cells (#908)
    - Bad workbook file format (#948)
	
  - Extended auto properties
    - Regex parser does not properly extract value from multiline text property with newlines (#41)
	
  - Property operations
    - Property setter - Specify search - Exclude source from search results setting ignored in dynamic conditions (#1059)

  - Reporting
    - Error with empty duplicate values (Source file from trigger) (#789)

  - Object creation
    - Duplicate detection - wrong object type setting (#1075)

  - Other
    - Invalid property change handling for comment and version label (#180)
    - Add all possible values to multi-value lookup (#937)
    - JSchema not generated due to license limitations (#971)

# 4.6.4
Released on 2023-11-08

- Bug fixes
  - Mapper
    - Correct config-diffs for PropertyErrorHandlingBehaviour in 4.4.0 (#970)

# 4.6.2
Released on 2023-09-07

- Bug fixes
  - Property operations
    - Regex functions not finding objects in lookup properties (#689)

# 4.6.0
Released on 2023-08-31

- Features
  - Document processing
    - New state action - SyncFileNamesWithObjectTitle (#507)

  - Excel integration 
    - Cell "Alias"/Name support (#175)
    - Add vertical and horizontal cells range to M-Files actions (#283)
    - Update source object (#339)
    - Add table range to M-Files actions (#443)
    - Replace name range or sheet content on target file (#515) 

  - SQL integration module
    - Add background execution mode (#577)

  - Other
    - Add One of and Not one of operators in dynamic search (#434)

- Bug fixes
  - Document processing
    - Line break doesn't work on text placeholder signatures (#152)
  
  - Validation module
    - Problem with One of operator (#631)

  - Reporting
    - Duplicated lines in excel report (#736)

# 4.4.14
Released on 2023-07-14

- Bug fixes
  - Excel integration
   - Clear error property on success after retry (#575)

  - Reporting
   - Duplicating items in excel report (#614)

# 4.4.12
Released on 2023-05-25

- Bug fixes
  - Extended assignments
   - Approvement object not added on source (#548)

# 4.4.10
Released on 2023-05-18

- Bug fixes
  - Property operations
   - Append text property from child objects to parent object is not working (#528)

# 4.4.8
Released on 2023-05-04

- Bug fixes
  - Excel integration
   - Custom database schemas bug (#508)

# 4.4.6
Released on 2023-04-12

- Bug fixes
  - Http integration
   - File update error on multifile object (#473)
  
  - Other
   - Scheduled rules are not scheduled when server is on UTC- timezone (#479)

# 4.4.4
Released on 2023-04-03

- Bug fixes
  - Configuration mapper
   - Configuration mapper move key failing when moving to child object (#417)

# 4.4.2
Released on 2023-03-29

- Bug fixes
  - Document processing
   - AddSignature action - get image path from placeholder text (#444)

# 4.4.0
Released on 2023-03-20

- Features
  - Http integration
    - Setting properties from multipart response (#160)
    - Remove empty elements from HTTP body (#403)

  - Excel integration 
    - Add name on excel action (#340)
    - Add enable option on excel action rule (#342) 

  - Extension methods
    - Allow executing scheduled rules without source object (#428)

  - Validation module
    - Added object deleted trigger (#427)

  - SQL integration module
    - Allow executing scheduled rules without source object (#309)

  - Other
    - Added Cron expressions to Frequency options in scheduled rules (#109)
    - Error handling behavior for property setters on single rule (#110)
    - Added ObjectProperty option in mapping property by ObjectLookup (#91)

- Bug fixes
  - Document processing
    - Error when adding new file on single-file object (#395)
  
  - Excel integration
    - Issue with schemas in database (#364)

# 4.2.16
Released on 2023-03-15 

- Bug fixes
  - Document processing
    - Document name changed when undoing PDF conversion (#425)

# 4.2.14
Released on 2023-03-08

- Bug fixes
  - HTTP integration
    - When file update is selected, the rule is looped (#415)
    - HTTP Response On Success does not work if response is 201: Created (#404)

# 4.2.12
Released on 2023-02-28

- Bug fixes
  - Logging
    - Logs are not displayed in dashboard (#411)
    
  - Other
    - Installation blocked (#410)
    - Scheduled rules not rescheduled (#412)
    
# 4.2.10
Released on 2023-02-20

- Bug fixes
  - Document processing
    - Document Processing version Label from gets overwritten (#394)

  - Orchestrator
    - Orchestrator rules not being scheduled (#397)

  - Other
    - Daily property recalculation not rescheduled (#392)
    - Messages forwarded from Event Log multiplicated in Seq (#363)
    - Multiple instances of scheduled rules running (#376)

# 4.2.8
Released on 2023-02-06

- Features
  - HTTP integration
    - Update file in vault from HTTP response (#92)
    - Set property both on error and on success (#147)
    - Logging improvements (#116)

  - Data transfer
    - Create single or multifile documents on import (#301)

  - Extended property operations
    - Contains operator error (#103)
    - When selected Copy mode is FromSourceToTarget add new option in rule config TriggerOnSourceOnly, and when is true rule will be triggered only when changes are made on source (#295)

  - Logging
    - Enable/disable app dashboard sink (#311)
    - Batching in dashboard log sink (#360)
    - Better event log forwarding (#363)

  - Configuration
    - Enable/disable configuration flag for rule groups (#196)
    - Separate OnDelete & OnDestroy triggers (#94)
    - Rename Object templates module (#298)
    - Improvements to Result M-Files property type (#107)

  - Extension methods
    - Specify search option (#104)

  - Other
    - Clear old transaction data from NVS (#359)

- Bug fixes
  - Configuration
    - Trigger object not shown in configuration when default trigger is used and Single object mode is selected in Calculated properties (#159)
    - Missing field for declaring static value (#297)

  - Data transfer
    - Too long path of temporary files (#300)

  - Auto Properties
    - Regex expression does not work with groups (#338)

  - Excel integration 
    - SQL query parameter values not included in error message (#361)

  - Extended reporting
    - Error handling for duplicate documents on object (#114)

  - Extended auto numbering properties
    - Custom numbering type - increment is not working as expected  (#204)

  - Other
    - Scheduled rules stop executing after some time (#195)
    - Lock conflict issue (#253)

# 4.2.6
Released on 2022-11-22

- Features
  - Excel integration
    - SQL sink in Excel integration module (#40)

  - HTTP integration
    - OAuth support in HTTP integration module (#139)

  - E-mail notifications
    - Option to send Digest e-mail as single or separate e-mails (#130)
    - Set properties option in E-mail notification rules (#138)

  - Orchestrator
    - Support for Auto properties in orchestration (#90)

  - Vault to vault
    - Better options when setitng lookup based target properties (#108)
  
  - Auto Numbering Properties
    - Integer format option in Simple numbering (#203)

  - Other
    - New module names in configuration (#212)

- Bug fixes

  - SQL integration module
    - Date Data Type missing in list of available properties for Stored procedure parameters (#58)
    - Missing configuration for SQL parmeter default value when Specify option is selected (#)

  - Extended reporting
    - Error generating Extended reporting export via mail when no trigger object is selected (#192)

  - HTTP integration
    - HTTP credentials not working when URL is dynamic expression (#197)
  
  - Orchestrator
    - Not all orchestrated rules get executed (#213)

  - Property operations
    - Event Handler task is triggered twice and object locks (#216)

  - Data transfer
    - Property setter for "Set as name" does not override default value (#217)
    - Too long path of temporary files generates 'FileNotFound' error (#219)
    - Files not imported when Hierarchy import is configured (#251)
    - Better log messages (#252)
  
  - Dashboard
    - Digest rules shown on dashboard as Run Once rules (#80)
    - Dashboard generation invalid character error (#83)

  - Configuration
    - Missing Trigger source settings when ObjectLeftState trigger is selected (#115)
    - Configuration mapping bugs (#56)
    
  - Other
    - Background Tasks errors not logged (#105)

# 4.2.4
Released on 2022-09-19

- Bug fixes
  - Extension method response not logged when extension method is executed
  - Conditions incorrectly not matched when changing workflow states in event handler

# 4.2.2
Released on 2022-08-23

Features
- Configuration
  - New dynamic search filter in trigger source

- Dashboard
  - Removed warning logs generated on dashboard refresh
  - Added Refresh button

- Sql integration module
  - Parameters for sql queries
  - Configurable timeout for sql queries

- Document processing module
  - Convert Word file before Merging with PDFs
  - Execution mode for Document Processing

- Extended property operations module
  - Changing workflow state property in event handler

Bug fixes

- Configuration
  - Duplicate values in multi select lookup properties behavior fixed
  - Digest rules not executed fixed
  - Security improvements

Sql integration module
- Return value mapping fixed
- Rollback query not executed fixed

- Data Transfer module
  - Wrong title used in Data Transfer file import fixed

- E-mail notifications module
  - Digest notification not working fixded

- Extended reporting module
  - Export on disk error fixed


# 4.2.1
Released on 2022-06-10

Features

- Sftp export option in Extended reporting, (#389)

Bug fixes

- Exporting on disk does not work in Extended reporting (#388)
- Dashboard unavailable when there are too many tasks (#387)
- Validation module - Bug in Does not contain operator (#386)

# 4.2.0
Released on 2022-05-23

Features

- Add delay option to all background tasks (#371)
- Support OR and AND operators in Dynamic search filters for Value from (#367)
- New option in ValueFrom: Specify (#361)
- Transactional and non-transactional background execution modes (#357)
- New module - AutoStateTransition (#333)

Bug fixes

- Missing error details in log when getting tasks for module fails (#384)
- Data transfer transaction timeout (#383)
- Data transfer deleting entire folder after file import (#380)
- Dynamic search stops too early (#379)
- Filename option in HTTP module allows invalid filenames (#378)
- Error details missing when commiting rule changes with error handling behavior continue (#375)
- Document processing placeholder signature formatting not working (#365)
- Schedule trigger not working (#353)

# 4.1.0
Released on 2022-03-21

Breaking change

- Extended options in Data transfer import/export (#344)

Features

- Orchestrated rule and module dropdowns in Orchestrator (#362)
- Service credentials improvements in HTTP module (#355)
- SQL parameter values logged (#350)
- Support referencing column names with their full name (schema + name, in square brackets) (#349)
- Debug logging improvements (#343)
- Vault Search with dynamic conditions in Document Processing (#340)
- File Parser in Auto properties module (#339)
- Support for multi file documents in HTTP body (#338)
- Filename dynamic HTTP body parameter (#336)
- Configurable rolling interval for log files and fixed retention policies labels (#335)
- Set multiple properties in SQL integration (#332)
- Network connection support in Data transfer module (#331)

Bug fixes

- Change all moveKey actions to pushUp in configuration remap json files (#360)
- Format lookups Auto properties expression does not work when no proeprty specified (#359)
- Wrong default value of stored procedure parameter (#351)
- Property condition for target vault not working in Vault to Vault module (#348)
- Trigger object not shown in Property Calculation rules (#347)
- Configuration mapper Move action does not work correctly with array items (#342)
- Process all delivery notifications, not just the first received (#341)
- Special characters not escaped in HTTP body (#337)
- Decimals not displayed correctly in HTTP json body (#329)
- Wrong execution context in Orchestrator module (#328)

# 4.0.3
Released on 2022-01-27

Features

- Match all or any property validation rules (#330)

# 4.0.2
Released on 2022-01-20

Features

- NOWTZ Auto properties function (#289)
- Deleted status condition (#285)

Bug fixes

- File import to Sftp server unsuccessful (#327)

# 4.0.1
Released on 2021-12-21

Features

- External ID in Status Field conditions (#319)
- Trusted hosts in HTTP integration module (#317)
- Dynamic values in status field conditions (#315)
- Option to delete/destroy object after successful export (#312)
- Optional property parameter in Format lookups Auto properties function (#311)
- Log file size limit (#307)

Bug fixes

- Document processing Merge action DeleteOriginalFile used even if its hidden in configuration (#313)
- Error in merge when Filename wildcards are not set (#310)
- Ambigous error message in property builder properties calculation (#309)

# 4.0.0
Released on 2021-12-06

Features

- VAF 2.3 migration (#304)

Bug fixes

- Outdated run once and recalculate data when executing commands (#283)

# 3.11.1
Released on 2021-11-26

Bug fixes

- Property builder configuration not mapped correctly (#306)
- Document processing merge state action deletes non merged file (#305)

# 3.11.0
Released on 2021-11-16

Features

- Remove template properties from new object in Extended object creation (#303)
- Template search and source as template in Extended object creation (#302)
- Rollback action in HTTP module (#301)
- Undo pdf conversion state action in Document processing (#300)
- Document processing merge action source file cannot be the same as the trigger file (#298)
- Undo merge state action in Document processing (#295)
- Rollback query in SQL integration (#294)

Bug fixes

- Decimal numbers incorrectly converted to text in cultures where comma is used as decimal separator (#299)
- Wrong iterator help text in Extended object creation configuration (#288)

# 3.10.2
Released on 2021-11-02

Bug fixes

- Run once and scheduled Extension methods rules not triggered (#291)
- Document processing tries to delete nonexisting file on merge (#290)

# 3.10.1
Released on 2021-10-27

Features

- Support for text based properties in SQL parameter property setter. (#287)

# 3.10.0
Released on 2021-10-20

Features

- Add Environment in the configuration that can be referenced with Alias in all modules. (#279)
- Exclude non working days in all date based functions (#278)
- Configurable Execution mode in Property operations (#277)
- Expand placeholders in textual SQL and HTTP parameters (#275)
- Vault to vault sync (#274)
- OnDelete trigger in SQL integration, HTTP integration and Extension methods modules (#273)
- Error handling behavior in SQL integration, HTTP integration and Extension methods modules (#271)
- Merge documents action in Document processing (#247)

Bug fixes

- Vault search result incorrectly set as rule source in Excel integration module (#281)
- Documet processing execution ignores filter conditions for matched rules (#280)
- LookInAllObjectVersions does not work for search conditions (#276)
- Limit max length of log message in dashboard (#272)

# 3.9.0
Released on 2021-08-03

Features

- Authentication for HTTP rule groups (#269)
- Support non numeric external IDs in SQL results (#265)
- Execution mode explained (#262)
- Excel integration module (#261)

# 3.8.1
Released on 2021-07-27

Bug fixes

- Extended object templates module not shown in configuration (#266)

# 3.8.0
Released on 2021-07-15

Features

- More options in Hourly schedule (#260)
- Yearly schedule (#259)
- Index lookups function (#257)
- Support for e-mail address lookup in HTTP and SQL parameters (#256)
- Support for files in HTTP, SQL parameters (#253)
- Remove existing watermark and signatures flag false by default (#252)
- Support for external IDs in integration modules (#250)
- Monitored properties condition (#248)
- Better logging in run once, scheduled and recalculate actions (#245)
- Rename code structures to reflect module names (#222)

Bug fixes

- Properties calculated incorrectly when depending on another calculated properties (#244)
- Add as aditional incorrect behavior (#211)

# 3.7.2
Released on 2021-06-16

Bug fixes

- Multiple e-mail adresses from property not parsed correctly (#251)

# 3.7.1
Released on 2021-06-08

Features

- Update metadata flag in Auto properties module (#249)

# 3.7.0
Released on 2021-05-15

Features

- Update metadata in file flag in Property calculations, Property operations and Object creation (#243)
- Business critical flag in rule config (#241)
- Mltiple files as attachments in e-mail notification (#237)
- Support for e-mail delivery notification (#236)

Bug fixes

- Signature size in document processing better explained (#242)
- Auto properties not working for multi select lookups (#240)
- Image signature not inserted (#239)
- Last object not exported (#238)
- Logging - Name of rules missing (#223)

# 3.6.0
Released on 2021-04-13

Features

- Recalculate option in property based modules (#224)
- Support for textbox over signature (#219)

Bug fixes

- Whitespace normalization (#226)
- Opacity not working on addsignature (#212)

# 3.5.3
Released on 2021-03-22

Features

- Exclude objects with nonempty property values from auto numbering recalculate (#213)
- Regex validation (#10)

Bug fixes

- Property recalculate executed too many times in property based modules (#215)
- Value list item based HTTP body variables always passed as string (#214)
